/*
 * Copyright © 2021-2023 Fachhochschule für die Wirtschaft (FHDW) Hannover
 *
 * This file is part of ipspiel24-VierConnects-core.
 *
 * ipspiel24-VierConnects-core is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * ipspiel24-VierConnects-core is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * ipspiel24-VierConnects-core. If not, see <http://www.gnu.org/licenses/>.
 */
package de.fhdw.gaming.ipspiel24.VierConnects.core.domain;

import de.fhdw.gaming.core.domain.GameBuilderFactory;
import de.fhdw.gaming.core.domain.GameException;
import de.fhdw.gaming.core.ui.InputProvider;

/**
 * A Vier Connects {@link GameBuilderFactory} which allows to create a Vier Connects game builder.
 */
public interface VierConnectsGameBuilderFactory extends GameBuilderFactory {

    /**
     * Parameter for the number of rows of the board.
     */
    String PARAM_NR_OF_ROWS = "nrOfRows";
    /**
     * Parameter for the number of rows of the board.
     */
    String PARAM_NR_OF_COLUMNS = "nrOfColumns";
    /**
     * Parameter that determines if a player is using crosses or noughts.
     */
    String PARAM_PLAYER_USING_CROSSES = "playerUsingCrosses";

    @Override
    VierConnectsGameBuilder createGameBuilder(InputProvider inputProvider) throws GameException;
}
